#ifndef CPP_TYPES_HPP
#define CPP_TYPES_HPP

/**
	Pulls in some very common types for global use. This should be limited to types that
	virtually all programs will end up using (those which almost should be C++ standard).
*/

#include <stdint.h>
#include <cstddef>
#include <memory>

#include <boost/shared_ptr.hpp>
#include <boost/scoped_array.hpp>

using boost::shared_ptr;
using boost::scoped_array;
using boost::dynamic_pointer_cast;
using boost::static_pointer_cast;
//C++11: using unique_ptr
using std::auto_ptr;

using std::size_t;
using std::ptrdiff_t;
typedef std::ptrdiff_t ssize_t;

#endif