#include <iostream>

template<typename TF>
void write_debug_output( std::ostream & out, TF const& f ) {
	out << f << std::endl;
}
	
template<typename TF, typename ... TR>
void write_debug_output( std::ostream & out, TF const& f, TR const& ... rest ) {
	out << f << " ";
	write_debug_output( out, rest... );
}

#define TRACE(...) write_debug_output( std::cout, __FILE__, __LINE__, __VA_ARGS__ )

int main()
{
	TRACE( "Hello" );
	TRACE( 123, 5.5 );
}
