#include <iostream>

template<typename T>
void apply(T&& value ) {
	std::cout << "apply" << std::endl;
}

struct my_type { };
template<>
void apply<my_type&&>(my_type && value ) {
	std::cout << "my_type&&" << std::endl;
}
template<>
void apply<my_type const&>(my_type const & value ) {
	std::cout << "my_type const&" << std::endl;
}
template<>
void apply<my_type &>(my_type & value ) {
	std::cout << "my_type const&" << std::endl;
}

int main() {
	apply( my_type() );
	my_type a;
	apply( a );
	apply( static_cast<my_type const>(a) );
	apply( static_cast<my_type const &>(a) );
}
