#define BOOST_TEST_MODULE mortorayTest
#define BOOST_TEST_DYN_LINK
#define BOOST_TEST_NO_MAIN
#include <boost/test/unit_test.hpp>
#include <boost/test/unit_test_monitor.hpp>
#include <boost/exception/all.hpp>

#include <iostream>

//otherwise boost just swallows the exceptions... :(
void boost_exception_translator( const boost::exception & /*ex*/ )
{
	//still in exception, so this works
	std::cout << boost::current_exception_diagnostic_information();
	throw;
}

void terminator()
{
	std::cerr << "Unexpected exception" << std::endl;
	std::cerr << boost::current_exception_diagnostic_information();
	exit(255);
}

int main( int argc, char** argv )
{
	std::set_terminate( &terminator );
	
	//show exceptions
	boost::unit_test::unit_test_monitor.register_exception_translator<boost::exception>( 
		&boost_exception_translator );
	
	//force boost to show entry/exit (otherwise error output is hard to track)
	setenv( "BOOST_TEST_LOG_LEVEL", "test_suite", 0 );
	return boost::unit_test::unit_test_main( &init_unit_test, argc, argv );
}
