#include <memory>

using namespace std;

struct A { };
struct B { };
struct A_D : public A { };

struct A_applicator {
	virtual void apply( shared_ptr<A> ) { }
};
struct B_applicator {
	virtual void apply( shared_ptr<B> ) { }
};
struct dual_applicator : public B_applicator, public A_applicator {
	using A_applicator::apply;
	using B_applicator::apply;
};

int main() {
	dual_applicator app;
	auto d = make_shared<A_D>();
	app.apply(d);
}
