#include "dsp.hpp"

#include <cmath>

namespace dsp
{

void gen_tone( audio_vector_t & av, size_t len, double freq, double sample_freq, double phase )
{
	double step = double(freq) / sample_freq * 2.0 * M_PI;

	double at = phase;
	for( size_t i =0; i < len; ++i, at += step )
		av.push_back( float(std::cos( at )) );
}

///////////////////////////////////////////////////////////
// I/Q Filter
void iq_filter::construct( double freq, double sample_freq, size_t len )
{
	dsp::gen_tone( av_i, len, freq, sample_freq, 0 );
	dsp::gen_tone( av_q, len, freq, sample_freq, M_PI_2 );
}

}
