# Automation tasks using Fabric
import fabric.api as fapi
import os

@fapi.hosts(['localhost'])
@fapi.task
def config_dev():
	"""Prepare machine for development"""
	fapi.sudo( 'pip install -e {}'.format( os.path.abspath( '.' ) ) )
	fapi.sudo( 'apt-get install pandoc python-epydoc' )
	fapi.sudo( 'pip install pypandoc setuptools' )

@fapi.task
def register():
	"""Registers a version of the package on pypi. Shouldn't need to run again."""
	fapi.local( 'python setup.py register' )

@fapi.task
def upload():
	"""Upload a new copy to pypi. Update the version in setup.py appropriately first."""
	docs()
	fapi.local( 'python setup.py sdist upload' )
	fapi.local( 'python setup.py upload_docs --upload-dir=shelljob/doc' )
	
@fapi.task
def docs():
	fapi.local( 'epydoc -v --html -o shelljob/doc shelljob' )
