//http://cs.stackexchange.com/questions/2079/determine-missing-number-in-data-stream
#include <iostream>
#include <vector>
#include <cstdlib>
#include <algorithm>

using namespace std;

void find_missing( int const * stream, int len );

int main( int argc, char ** argv )
{
	if( argc < 2 )
	{
		cerr << "Syntax: " << argv[0] << " N" << endl;
		return 1;
	}
	int n = atoi( argv[1] );

	//construct sequence
	vector<int> seq;
	for( int i=1; i <= n; ++i )
		seq.push_back( i );

	//remove a number and remember it
	srand( unsigned(time(0)) );
	int remove = (rand() % n) + 1;
	seq.erase( seq.begin() + (remove - 1) );
	cout << "Removed: " << remove << endl;

	//give the stream a random order
	std::random_shuffle( seq.begin(), seq.end() );

	find_missing( &seq[0], int(seq.size()) );
}

//HdM's solution
void find_missing( int const * stream, int len )
{
	//create initial value of n sequence xor'ed (n == len+1)
	int value = 0;
	for( int i=0; i < (len+1); ++i )
		value = value ^ (i+1);

	//xor all items in stream
	for( int i=0; i < len; ++i, ++stream )
		value = value ^ *stream;

	//what's left is the missing number
	cout << "Found: " << value << endl;
}
